#include "MainCUIThread.h"

#include "icp_func.h"
#include "DoRotation.h"
#include "SharedData.h"

#define ROLL0 0
#define PITCH0 0
#define YAW0 0

#define PRE_MODEL_NUM 27

extern int model_No;

#include <rtm/Manager.h>
extern RTC::ReturnCode_t on_execute_return_code;

#define CHECK_NULL(x)                            \
{                                                \
	if ((x) == NULL) {                           \
		on_execute_return_code = RTC::RTC_ERROR; \
		this->break_flag_ = true;                \
		data_point.unlock();                     \
		model_point.unlock();                    \
		return;                                  \
	}                                            \
}

#define SLEEP_CUI_THREAD(x)                      \
{                                                \
	for(int i=0; i < x; ++i) {                   \
		if (this->break_flag_ == true) return;   \
		Sleep(1000);                             \
	}                                            \
}                                            

#define PAUSE()                                  \
{                                                \
	while(true) {                                \
		SLEEP_CUI_THREAD(1);                     \
	}                                            \
}

MainCUIThread::MainCUIThread(void)
: CUIThread()
{
}

MainCUIThread::~MainCUIThread(void)
{
}

bool MainCUIThread::cui_init()
{
	graphics.stop();
	return true;
}

void MainCUIThread::cui_finish()
{
	graphics.stop();
}

void MainCUIThread::cui_run()
{
	int i,j,k;	
	int data_point_num;
	int model_point_num;

	//f[^ƃfԍwqsbGetX^[g
	while(model_No == -1){
		SLEEP_CUI_THREAD(1);	
	}
	int c_No = model_No;

	// `pXbh̋N
	graphics.start();

	int readcount = 0;

	//NH[^jI
	MOVEMENT delta;
	delta.Q.q0 = 1;
	delta.Q.q1 = 0;
	delta.Q.q2 = 0;
	delta.Q.q3 = 0;
	delta.Trl.x = 0;
	delta.Trl.y = 0;
	delta.Trl.z = 0;

	DATA_POINT *data_set, *model_set, *data2, *model_gravi;

	CvMat *Src = cvCreateMat(3,1,CV_32FC1);	
	CvMat *Dst = cvCreateMat(3,1,CV_32FC1);	

	//p[^̏----------------------------------------------------------
	float x_distanse = 0.0;
	float data_rollangle = 0.0;
	float data_pitchangle = 0.0;
	float data_yawangle = 0.0;
	float data_scale = 1.0;
	float model_rollangle = 0.0;
	float model_pitchangle = 0.0;
	float model_yawangle = 0.0;
	float model_scale = 1.0;
	int RightF = 1;
	int LeftF = 0;
	//p[^̎荞---------------------------------------------------------
	FILE *fpara;
	char c_para[] = "tactile_parameter";
	char c_paraNoTxt[30];
	sprintf(c_paraNoTxt,"%s%d.txt",c_para,c_No);
	printf("\n%s--\n",c_paraNoTxt);
	fpara = fopen(c_paraNoTxt,"r"); 
	CHECK_NULL(fpara);
	fscanf(fpara,"x_distanse,%f\n",&x_distanse);
	fscanf(fpara,"data_rollangle,%f\n",&data_rollangle);
	fscanf(fpara,"data_pitchangle,%f\n",&data_pitchangle);
	fscanf(fpara,"data_yawangle,%f\n",&data_yawangle);
	fscanf(fpara,"data_scale,%f\n",&data_scale);
	fscanf(fpara,"model_rollangle,%f\n",&model_rollangle);
	fscanf(fpara,"model_pitchangle,%f\n",&model_pitchangle);
	fscanf(fpara,"model_yawangle,%f\n",&model_yawangle );
	fscanf(fpara,"model_scale,%f\n",&model_scale);
	fscanf(fpara,"model_scale,%f\n",&model_scale);
	fscanf(fpara,"RightF,%d\n",&RightF);
	fscanf(fpara,"LeftF,%d\n",&LeftF);
	fclose(fpara);
	printf("x_distanse = %f\n",x_distanse);
	printf("data_rollangle = %f\n",data_rollangle);
	printf("data_pitchangle = %f\n",data_pitchangle);
	printf("data_yawangle = %f\n",data_yawangle);
	printf("data_scale = %f\n",data_scale);
	printf("model_rollangle = %f\n",model_rollangle);
	printf("model_pitchangle = %f\n",model_pitchangle);
	printf("model_yawangle = %f\n",model_yawangle);
	printf("model_scale = %f\n",model_scale);
	printf("RightF = %d\n",RightF);
	printf("LeftF = %d\n",LeftF);

	int kk = 0;
	//f[^荞----------------------------------------------------------

	float raw_data_x[MAX_DATA_NUM];
	float raw_data_y[MAX_DATA_NUM];
	float raw_data_z[MAX_DATA_NUM];
	int dummy = 0;
	k=0;j=0;
	float dummyf1 = 0.0, dummyf2 = 0.0, dummyf3 = 0.0, dummyf4 = 0.0, dummyf5 = 0.0, dummyf6 = 0.0;
    data_from_rtc.lock();
	for(k=0;k<(data_from_rtc.num/3);k+=2){	
		if(RightF == 1 && LeftF == 1){
			raw_data_x[k]   = data_from_rtc.d1[k]; 
			raw_data_y[k]   = data_from_rtc.d2[k];  
			raw_data_z[k]   = data_from_rtc.d3[k]; 
			raw_data_x[k+1] = data_from_rtc.d1[k+1];  
			raw_data_y[k+1] = data_from_rtc.d2[k+1]; 
			raw_data_z[k+1] = data_from_rtc.d3[k+1]; 
			printf("%d [%f %f %f] \n",k, raw_data_x[k], raw_data_y[k], raw_data_z[k]);	
			printf("%d [%f %f %f] \n",k+1, raw_data_x[k+1], raw_data_y[k+1], raw_data_z[k+1]);	
			j++;
		}
		if(RightF == 1 && LeftF == 0){
			raw_data_x[j] = data_from_rtc.d1[k]; 
			raw_data_y[j] = data_from_rtc.d2[k]; 
			raw_data_z[j] = data_from_rtc.d3[k];
			printf("%d [%f %f %f] \n",j, raw_data_x[j], raw_data_y[j], raw_data_z[j]);		
			j++;
		}				
		if(RightF == 0 && LeftF == 1){
			raw_data_x[j] = data_from_rtc.d1[k+1]; 
			raw_data_y[j] = data_from_rtc.d2[k+1]; 
			raw_data_z[j] = data_from_rtc.d3[k+1];
			printf("%d [%f %f %f] \n",j, raw_data_x[j], raw_data_y[j], raw_data_z[j]);		
			j++;
		}					
	}
	data_from_rtc.unlock();

	if(RightF == 1 && LeftF == 1){
		data_point_num = j*2;	
	}else{
		data_point_num = j;
	}

	//ϒlZo
	float raw_sum[3] = {0.0,0.0,0.0};
	for(i=0;i<data_point_num;i++){
		raw_sum[0] += raw_data_x[i];
		raw_sum[1] += raw_data_y[i];
		raw_sum[2] += raw_data_z[i];
	}
	printf("raw_sumx=%f\n",raw_sum[0]);
	printf("raw_sumy=%f\n",raw_sum[1]);
	printf("raw_sumz=%f\n",raw_sum[2]);
	raw_sum[0] /= data_point_num;
	raw_sum[1] /= data_point_num;	
	raw_sum[2] /= data_point_num;	
	//ϒl
	for(i=0;i<data_point_num;i++){
		raw_data_x[i] -= raw_sum[0]; 
		raw_data_y[i] -= raw_sum[1]; 
		raw_data_z[i] -= raw_sum[2]; 
	}

	printf("\ndata_point_num=%d\n",data_point_num);
	printf("raw_avg_x=%f\n",raw_sum[0]);
	printf("raw_avg_y=%f\n",raw_sum[1]);
	printf("raw_avg_z=%f\n",raw_sum[2]);	

	for(i=0;i<data_point_num;i++){
		raw_data_x[i] *= data_scale;
		raw_data_y[i] *= data_scale; 
		raw_data_z[i] *= data_scale; 
	}

	data_set = (DATA_POINT*)malloc(sizeof(DATA_POINT));
	data_set->num = data_point_num ;
	data_set->pt = (CvPoint3D64f*)malloc(data_point_num * sizeof(CvPoint3D64f));
	
	data2 = (DATA_POINT*)malloc(sizeof(DATA_POINT));
	data2->num = data_point_num ;
	data2->pt = (CvPoint3D64f*)malloc(data_point_num * sizeof(CvPoint3D64f));
	

	//ff[^荞------------------------------------------------------
	float tmpx = 0.0, tmpy = 0.0, tmpz = 0.0;
	FILE *fk;
	char c_tactile[] = "tactile_model";
	char c_tactNoTxt[22];
	sprintf(c_tactNoTxt,"%s%d.txt",c_tactile,c_No);
	printf("\n%s--\n",c_tactNoTxt);
	fk = fopen(c_tactNoTxt,"r"); 
	CHECK_NULL(fk);
	float model_data_x[MAX_MODEL_NUM];
	float model_data_y[MAX_MODEL_NUM];
	float model_data_z[MAX_MODEL_NUM];
	k = 0;
	kk = 0;
	dummy = 0;
	while(1){

		if(k > MAX_MODEL_NUM)break;
		fscanf(fk,"%d,%f,%f,%f",&dummy,&(tmpx),&(tmpy),&(tmpz));
		if(dummy == EOF )break;
		
			model_data_x[k] = tmpx;
			model_data_y[k] = tmpy;
			model_data_z[k] = tmpz;
			printf("%d,(%f,%f,%f)\n",dummy, model_data_x[k], model_data_y[k], model_data_z[k]);		
			k++;	
		
		kk++;

	}
	fclose(fk);
	model_point_num = k;
	printf("model_point_num = %d\n",model_point_num);
	//ϒlZo
	float model_sum_x = 0;
	float model_sum_y = 0;
	float model_sum_z = 0;	
	for(i=0;i<model_point_num;i++){
		model_sum_x += model_data_x[i];
		model_sum_y += model_data_y[i];
		model_sum_z += model_data_z[i];
	}
	printf("model_sum_x=%f\n",model_sum_x);
	printf("model_sum_y=%f\n",model_sum_y);
	printf("model_sum_z=%f\n",model_sum_z);

	model_sum_x /= (float)model_point_num;
	model_sum_y /= (float)model_point_num;	
	model_sum_z /= (float)model_point_num;	
	//ϒl
	for(i=0;i<model_point_num;i++){
		model_data_x[i] -= model_sum_x; 
		model_data_y[i] -= model_sum_y; 
		model_data_z[i] -= model_sum_z; 
	}
	for(i=0;i<model_point_num;i++){
		model_data_x[i] *= model_scale; 
		model_data_y[i] *= model_scale; 
		model_data_z[i] *= model_scale; 
	}

	printf("\nmodel_point_num=%d\n",model_point_num);
	printf("model x avg=%f\n",model_sum_x);
	printf("model y avg=%f\n",model_sum_y);
	printf("model z avg=%f\n",model_sum_z);
	model_set = (DATA_POINT*)malloc(sizeof(DATA_POINT));
	model_set->num = model_point_num ;
	model_set->pt = (CvPoint3D64f*)malloc(model_point_num * sizeof(CvPoint3D64f));

	model_gravi = (DATA_POINT*)malloc(sizeof(DATA_POINT));
	model_gravi->num = 4; 
	model_gravi->pt = (CvPoint3D64f*)malloc(4*sizeof(CvPoint3D64f));
	

	//f[^̉H------------------------------------------------------	
	k = 0;
	i = 0;
	data_point.lock();
	for(j=0; j < data_point_num; j++){
		data2->pt[k].x = raw_data_x[k];
		data2->pt[k].y = raw_data_y[k];
		data2->pt[k].z = raw_data_z[k];
		cvmSet(Src,0,0,data2->pt[k].x);
		cvmSet(Src,1,0,data2->pt[k].y);
		cvmSet(Src,2,0,data2->pt[k].z);
		
		DoRotation(Src, Dst,  data_rollangle*M_PI/180.0, data_pitchangle*M_PI/180.0, data_yawangle*M_PI/180.0);			
		
		data_set->pt[k].x = cvGet2D(Dst,0,0).val[0];
		data_set->pt[k].y = cvGet2D(Dst,1,0).val[0];
		data_set->pt[k].z = cvGet2D(Dst,2,0).val[0];		
			
		data_point.x[j] = (float)data_set->pt[k].x;
		data_point.y[j] = (float)data_set->pt[k].y;
		data_point.z[j] = (float)data_set->pt[k].z;

		printf("%f,\t%f,\t%f\n",data_point.x[j],data_point.y[j],data_point.z[j]);

		k++;
	}
	data_point.num = data_point_num;
	data_point.unlock();
	printf("k=%d\n",k);

	model_point.lock();
	//f̉H------------------------------------------------------
	for(k=0;k<model_point_num;k++){	

		cvmSet(Src,0,0,model_data_x[k] + x_distanse );
		cvmSet(Src,1,0,model_data_y[k]);
		cvmSet(Src,2,0,model_data_z[k]);
		DoRotation(Src, Dst,  model_rollangle*M_PI/180.0, model_pitchangle*M_PI/180.0, model_yawangle*M_PI/180.0);	
		model_set->pt[k].x = cvGet2D(Dst,0,0).val[0];
		model_set->pt[k].y = cvGet2D(Dst,1,0).val[0];
		model_set->pt[k].z = cvGet2D(Dst,2,0).val[0];	
		model_point.x[k] = (float)model_set->pt[k].x;
		model_point.y[k] = (float)model_set->pt[k].y; 
		model_point.z[k] = (float)model_set->pt[k].z; 
	}
	model_point.num = model_point_num;
	
	//dS_
	model_gravi->pt[0].x = x_distanse;
	model_gravi->pt[0].y = 0.0;
	model_gravi->pt[0].z = 0.0;
	//dS̕xNg
	model_gravi->pt[1].x = model_gravi->pt[0].x + 1.0;
	model_gravi->pt[1].y = model_gravi->pt[0].y + 0.0;
	model_gravi->pt[1].z = model_gravi->pt[0].z + 0.0;
	model_gravi->pt[2].x = model_gravi->pt[0].x + 0.0;
	model_gravi->pt[2].y = model_gravi->pt[0].y + 1.0;
	model_gravi->pt[2].z = model_gravi->pt[0].z + 0.0;
	model_gravi->pt[3].x = model_gravi->pt[0].x + 0.0;
	model_gravi->pt[3].y = model_gravi->pt[0].y + 0.0;
	model_gravi->pt[3].z = model_gravi->pt[0].z + 1.0;	
	//model gravi
	model_point.gravi[0] = (float)model_gravi->pt[0].x;
	model_point.gravi[1] = (float)model_gravi->pt[0].y;
	model_point.gravi[2] = (float)model_gravi->pt[0].z;
	//model gravi direction
	model_point.ref_point[0][0] = (float)model_gravi->pt[1].x;
	model_point.ref_point[0][1] = (float)model_gravi->pt[1].y;
	model_point.ref_point[0][2] = (float)model_gravi->pt[1].z;
	model_point.ref_point[1][0] = (float)model_gravi->pt[2].x;
	model_point.ref_point[1][1] = (float)model_gravi->pt[2].y;
	model_point.ref_point[1][2] = (float)model_gravi->pt[2].z;
	model_point.ref_point[2][0] = (float)model_gravi->pt[3].x;
	model_point.ref_point[2][1] = (float)model_gravi->pt[3].y;
	model_point.ref_point[2][2] = (float)model_gravi->pt[3].z;

	model_point.unlock();


	//ff[^̎pAXP[Aʒu̕ύX
	int c_key = 0, d_key = 0, e_key = 0, f_key = 0;
	int breakpoint = 0;

	while(1){
		printf("1:Change distanse between model and measured data\n");		
		printf("2:Change model posture\n");	
		printf("3:Change model scale\n");
		printf("4:Change measured data posture\n");	
		printf("5:Change measured data scale\n");
		printf("6:Save parameter\n");
		printf("7:Matching start\n");
		READ_INT_FROM_STDIN(c_key);
		switch(c_key){
			case 1:
				printf("Input distanse \n"); READ_INT_FROM_STDIN(d_key); x_distanse = (float)d_key;
				break;
			case 2:
				printf("Input [model] roll angle  \n"); READ_INT_FROM_STDIN(d_key); model_rollangle = (float)d_key;
				printf("Input [model] pitch angle \n"); READ_INT_FROM_STDIN(e_key); model_pitchangle = (float)e_key;
				printf("Input [model] yaw angle   \n"); READ_INT_FROM_STDIN(f_key); model_yawangle = (float)f_key;
				break;	
			case 3:
				printf("Input [model] scale \n"); READ_FLOAT_FROM_STDIN(model_scale); 
				break;
			case 4:
				printf("Input [measured data] roll angle  \n"); READ_INT_FROM_STDIN(d_key); data_rollangle = (float)d_key;
				printf("Input [measured data] pitch angle \n"); READ_INT_FROM_STDIN(e_key); data_pitchangle = (float)e_key;
				printf("Input [measured data] yaw angle   \n"); READ_INT_FROM_STDIN(f_key); data_yawangle = (float)f_key;
				break;	
			case 5:
				printf("Input [measured data] scale \n");READ_FLOAT_FROM_STDIN(data_scale); 
				break;			
			case 6:
				//save
				FILE *fpara;
				fpara = fopen("parameter.txt","w");
				CHECK_NULL(fpara);
				fprintf(fpara,"x_distanse:%f\n",      x_distanse      );
				fprintf(fpara,"data_rollangle:%f\n",  data_rollangle  );
				fprintf(fpara,"data_pitchangle:%f\n", data_pitchangle );
				fprintf(fpara,"data_yawangle:%f\n",   data_pitchangle );
				fprintf(fpara,"data_scale:%f\n",      data_scale      );
				fprintf(fpara,"model_rollangle:%f\n", model_rollangle );
				fprintf(fpara,"model_pitchangle:%f\n",model_pitchangle);
				fprintf(fpara,"model_yawangle:%f\n",  model_pitchangle);
				fprintf(fpara,"model_scale:%f\n",     model_scale     );
				fclose(fpara);
				break;
			case 7:
				breakpoint = 1;
				break;
			default:
				break;
		}
		if(breakpoint == 1){
			break;
		}
		
		data_point.lock();
		for(k=0;k<data_point_num;k++){	
			cvmSet(Src,0,0, data_scale*raw_data_x[k]);
			cvmSet(Src,1,0, data_scale*raw_data_y[k]);
			cvmSet(Src,2,0, data_scale*raw_data_z[k]);
			DoRotation(Src, Dst,  data_rollangle*M_PI/180.0, data_pitchangle*M_PI/180.0, data_yawangle*M_PI/180.0);
			data_set->pt[k].x = cvGet2D(Dst,0,0).val[0];
			data_set->pt[k].y = cvGet2D(Dst,1,0).val[0];
			data_set->pt[k].z = cvGet2D(Dst,2,0).val[0];	
			data_point.x[k] = (float)data_set->pt[k].x;
			data_point.y[k] = (float)data_set->pt[k].y; 
			data_point.z[k] = (float)data_set->pt[k].z; 
		}	
		data_point.unlock();

		model_point.lock();
		for(k=0;k<model_point_num;k++){	
			cvmSet(Src,0,0,model_scale*model_data_x[k]);
			cvmSet(Src,1,0,model_scale*model_data_y[k]);
			cvmSet(Src,2,0,model_scale*model_data_z[k]);
			DoRotation(Src, Dst,  model_rollangle*M_PI/180.0, model_pitchangle*M_PI/180.0, model_yawangle*M_PI/180.0);
			model_set->pt[k].x = x_distanse + cvGet2D(Dst,0,0).val[0];
			model_set->pt[k].y = cvGet2D(Dst,1,0).val[0];
			model_set->pt[k].z = cvGet2D(Dst,2,0).val[0];	
			model_point.x[k] = (float)model_set->pt[k].x;
			model_point.y[k] = (float)model_set->pt[k].y; 
			model_point.z[k] = (float)model_set->pt[k].z; 
		}	
		model_point.unlock();
	}
	printf("start icp_func!\n");

	//ICP
	icp_func(&delta, data_set, model_set, model_gravi, data_point_num, model_point_num, raw_sum);

	Free_Data_Points(model_gravi);
	Free_Data_Points(data2);
	Free_Data_Points(model_set);
	Free_Data_Points(data_set);

	printf("\n main ok \n");
			
	PAUSE();
}

