#pragma once
#include "LockObject.h"

#define MAX_MODEL_NUM 1500
#define MAX_DATA_NUM 1500

class SharedObject
{
protected:
	LockObject lock_;

public:
	SharedObject();
	virtual ~SharedObject();

	void lock();
	void unlock();
};

// f[^i[pNX
class DataPoint : public SharedObject
{
public:
	int num;
	float x[MAX_DATA_NUM];
	float y[MAX_DATA_NUM];
	float z[MAX_DATA_NUM];

public:
	DataPoint(void);
	virtual ~DataPoint(void);

	void clear();
};

// ff[^i[pNX
class ModelPoint : public SharedObject
{
public:
	int num;
	float x[MAX_MODEL_NUM];
	float y[MAX_MODEL_NUM];
	float z[MAX_MODEL_NUM];
	float gravi[3];
	float ref_point[3][3];

public:
	ModelPoint();
	virtual ~ModelPoint();

	void clear();
};

//}b`Of̏dSʒui[pNX
class ResultData : public SharedObject
{
public:
	float result[20];

public:
	ResultData();
	virtual ~ResultData();

	void clear();
};

//RTC瑗Ăwʒuf[^i[pNX
class DataFromRTC : public SharedObject
{
public:
	int num;
	float d1[MAX_DATA_NUM];
	float d2[MAX_DATA_NUM];
	float d3[MAX_DATA_NUM];

public:
	DataFromRTC();
	virtual ~DataFromRTC();

	void clear();
};

extern DataPoint data_point;
extern ModelPoint model_point;
extern ResultData result_data;
extern DataFromRTC data_from_rtc;